minix/tools/mkboot

184 lines
4.7 KiB
Plaintext
Raw Normal View History

2005-04-21 16:53:53 +02:00
#!/bin/sh
#
# mkboot 2.0 - make boot floppy, make root device bootable, etc.
# Author: Kees J. Bot
trap 'e=$?; rm -f /tmp/mkb.$$; exit $e' 0 2
mdec=/usr/mdec # bootstraps
# Check arguments.
case "$#:$1" in
1:bootable | 1:hdboot | [12]:fdboot | 1:cdfdboot )
action=$1 dev=$2
;;
*) echo "Usage: $0 [bootable | hdboot | cdfdboot | fdboot [device]]" >&2
exit 1
esac
# Get the device table.
. /etc/fstab
# The real root device may be the RAM disk.
realroot=`printroot -r`
2005-05-03 10:54:36 +02:00
# If it's an initial fstab, pretend root is real root
if [ $root = "/dev/ROOT" ]
then root=$realroot
fi
2005-04-21 16:53:53 +02:00
case $action in
bootable | hdboot)
# We need the root device.
2005-05-03 10:54:36 +02:00
2005-04-21 16:53:53 +02:00
if [ $realroot = $root ]
then
rootdir=
else
umount $root 2>/dev/null
mount $root /mnt || exit
rootdir=/mnt
fi
esac
case $action in
bootable)
# Install the boot monitor on the root device and make it bootable.
install -cs -m 644 $mdec/boot $rootdir/boot/boot || exit
sync
installboot -device $root $mdec/bootblock /boot/boot || exit
test $realroot != $root && umount $root
;;
hdboot)
# Install a new image on the root device.
if [ ! -d $rootdir/boot/image ]
then
/boot/image is not yet a directory! Fix it.
2005-04-21 16:53:53 +02:00
su root -c \
"exec mv $rootdir/boot/image /M"
install -d $rootdir/boot/image
su root -c \
"exec mv $rootdir/M $rootdir/boot/image/`uname -r`.`uname -v`"
fi
sh tell_config OS_RELEASE . OS_VERSION >/tmp/mkb.$$
2005-04-21 16:53:53 +02:00
version=`sed 's/[" ]//g;/^$/d' </tmp/mkb.$$`
revision=`cat revision 2>/dev/null`
oldrev=$revision
target="${version}r${revision}"
if [ -z "$revision" ]
then
revision=0
elif [ -f $rootdir/boot/image/$target ]
then
if [ $rootdir/boot/image/$target -newer image ]
then
echo "$root:/boot/image/$target is up to date"
test $realroot != $root && umount $root
exit 0
fi
revision=`expr $revision + 1`
fi
target="${version}r${revision}"
set -- `ls -t $rootdir/boot/image`
case $# in
0|1|2|3)
2005-04-21 16:53:53 +02:00
# Not much there, do not remove a thing.
;;
*)
# Remove the third-newest image in /boot/image, but
# only if there's an older one (which is kept).
echo "rm $root:/boot/image/$3"
rm -f "$rootdir/boot/image/$3"
2005-04-21 16:53:53 +02:00
esac
# Install the new image.
echo "install image $root:/boot/image/$target"
install -o root -m 600 image $rootdir/boot/image/$target || exit
2005-04-21 16:53:53 +02:00
# Save the revision number.
test "$revision" != "$oldrev" && echo $revision >revision
test $realroot != $root && umount $root
echo "Done."
;;
fdboot)
# fdboot: Make a boot floppy.
if [ -z "$dev" ]
then
echo -n \
"Finish the name of the floppy device to write (by default 'fd0'): /dev/";
read dev
case "$dev" in
'') dev=/dev/fd0
;;
/dev/*)
;;
*) dev=/dev/$dev
esac
fi
# Make a file system.
umount $dev 2>/dev/null
2005-06-29 14:04:10 +02:00
if mkfs -B 1024 -i 512 $dev
then :
else
echo "mkfs of $dev failed."
exit 1;
fi
2005-04-21 16:53:53 +02:00
# Install /dev, /boot/boot and /boot/image.
mount $dev /mnt || exit
2005-05-12 18:07:31 +02:00
mkdir -p /mnt/boot/image || exit
2005-04-21 16:53:53 +02:00
cpdir /dev /mnt/dev || exit
cp -p $mdec/boot /mnt/boot/boot || exit
cp -p image /mnt/boot/image/ || exit
umount $dev || exit
# Make bootable and copy the boot parameters.
installboot -d $dev $mdec/bootblock /boot/boot || exit
pfile=fdbootparams
if [ -f $pfile ]
then echo "Using floppy boot parameters from file $pfile."
edparams $dev "`cat $pfile`" || exit
else echo "Copying floppy boot parameters from $root."
dd if=$root of=$dev skip=1 seek=1 count=1 conv=silent || exit
fi
2005-04-21 16:53:53 +02:00
edparams $dev 'main(){delay 2000;boot}; save' || exit
echo "Test kernel installed on $dev"
2005-04-21 16:53:53 +02:00
;;
cdfdboot)
# cdfdboot: Make a boot floppy image to go on a CD for booting from.
dev=/dev/ram
umount $dev 2>/dev/null
2005-06-29 14:04:10 +02:00
if mkfs -B 1024 -b 1440 -i 512 $dev || exit 1
then :
else
echo "mkfs of $dev failed."
exit 1;
fi
2005-04-21 16:53:53 +02:00
# Install /dev, /boot
mount $dev /mnt || exit 1
mkdir /mnt/dev
2005-05-03 10:54:36 +02:00
mkdir /mnt/boot
mkdir /mnt/boot/image
( cd /mnt/dev && sh /usr/src/commands/scripts/MAKEDEV.sh std )
2005-08-29 21:59:58 +02:00
cp -p image image_* /mnt/boot/image || exit 1
2005-05-03 10:54:36 +02:00
cp -p ../boot/boot /mnt/boot/boot || exit 1
2005-04-21 16:53:53 +02:00
umount $dev || exit 1
2005-05-03 10:54:36 +02:00
installboot -d $dev ../boot/bootblock boot/boot || exit 1
2005-09-19 15:28:37 +02:00
edparams $dev 'unset bootopts; unset servers; disable=inet; image=/boot/image/image_big; bootbig(1, Regular MINIX 3 (requires at least 16 MB RAM)) { image=/boot/image/image ; boot } bootsmall(2, Small MINIX 3 (intended for 8 MB systems)) { image=/boot/image/image_small ; boot } cdproberoot=1; unset rootdev; unset leader; leader() { echo \n--- Welcome to MINIX 3. This is the boot monitor. ---\n\nChoose an option from the menu or press ESC if you need to do anything special.\nOtherwise I will boot with my defaults in 10 seconds.\n\n }; bootcd=1; main(){trap 10000 boot; menu; }; save' || exit
2005-04-21 16:53:53 +02:00
# copy image
dd if=$dev of=cdfdimage bs=8192 count=180
esac
sync
2005-04-21 16:53:53 +02:00
exit 0